//-----------------------------------------------------------------------------------------// 
// +-------------------------------------------------------------------------------------+ //
// |                                     PX4_FX.mq4                                      | //
// |                               N Roets Copyright 2006                                | //
// |                               Works on M15 timeframe                                | //
// |                      Place on USDCHFm, USDJPYm, EURUSDm & GBPUSDm                   | //
// +-------------------------------------------------------------------------------------+ //
//-----------------------------------------------------------------------------------------// 

#property copyright "Nico Roets Copyright  2006"

extern double lots=1.0;
extern int MaxTrades=1;
extern bool ManageMoney = true;
extern int Risk = 2;
extern bool ProfitTrailing = true;  
extern bool UseSound = true;  

extern int StopLoss = 22;
extern int TakeProfit = 10;
extern int TrailingStop = 8;   
int TrailingStep = 1;   
string NameFileSound  = "expert.wav";  


int IDT;
void deinit() {
   Comment("");
}

//--------------------------------------------------------------------------------------// 

int orderscnt(){
int cnt=0;
   for(int i =0;i<OrdersTotal();i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()==Symbol() && IDT==OrderMagicNumber()){
            cnt++;
         }
      }
   }
   return(cnt);
}

//--------------------------------------------------------------------------------------// 

int start(){

 for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      TrailingPositions();
    }
  }

   if(orderscnt()<MaxTrades){
      if(ManageMoney==true) lots = LotSize();
      if (MathMod(Minute(),Period()) >= 0.5*Period()) return(0);
      CheckOpen();
      //if(CurTime()-OrderOpenTime()<61) return(0);
      
   }   
}

//--------------------------------------------------------------------------------------// 

void CheckOpen(){
 
  bool Buy, Sell;

double RSIb=iRSI(NULL,60,3,PRICE_CLOSE,0);
double RSIs=iRSI(NULL,60,3,PRICE_CLOSE,0);

Buy = False;
if (RSIb<20)
Buy = True;

Sell = False;
if (RSIs>80)
Sell = True;

  
   double TP,SL;
//--------------------------------------------------------------------------------------// 
   if (Buy){
      if(StopLoss==0){SL=0;}else{SL=Ask-StopLoss*Point;}
      if(TakeProfit==0){TP=0;}else{TP=Ask+TakeProfit*Point;}
      OrderSend(Symbol(),OP_BUY,lots,Ask,1,SL,TP,"PX4",IDT,0,LawnGreen); 
   }
   if (Sell){
      if(StopLoss==0){SL=0;}else{SL=Bid+StopLoss*Point;}
      if(TakeProfit==0){TP=0;}else{TP=Bid-TakeProfit*Point;}
      OrderSend(Symbol(),OP_SELL,lots,Bid,1,SL,TP,"PX4",IDT,0,HotPink); 
   }
}
//--------------------------------------------------------------------------------------// 
double LotSize(){
   double lotMM = MathCeil(AccountFreeMargin() * Risk / 1000)/10;  
   if (lotMM < 0.1) lotMM = lots;
   if (lotMM > 1.0) lotMM = MathCeil(lotMM);
   if  (lotMM > 50) lotMM = 50;
   return (lotMM);
} 
//--------------------------------------------------------------------------------------// 
void TrailingPositions() {
  double pBid, pAsk, pp;

  pp = MarketInfo(OrderSymbol(), MODE_POINT);
  if (OrderType()==OP_BUY) 
  {
    pBid = MarketInfo(OrderSymbol(), MODE_BID);
    if (!ProfitTrailing || (pBid-OrderOpenPrice())>TrailingStop*pp) 
    {
      if (OrderStopLoss()<pBid-(TrailingStop+TrailingStep-1)*pp) 
      {
        ModifyStopLoss(pBid-TrailingStop*pp);
        return;
      }
    }
  }
  if (OrderType()==OP_SELL) 
  {
    pAsk = MarketInfo(OrderSymbol(), MODE_ASK);
    if (!ProfitTrailing || OrderOpenPrice()-pAsk>TrailingStop*pp) 
    {
      if (OrderStopLoss()>pAsk+(TrailingStop+TrailingStep-1)*pp || OrderStopLoss()==0) 
      {
        ModifyStopLoss(pAsk+TrailingStop*pp);
        return;
      }
    }
  }
}
//--------------------------------------------------------------------------------------// 
void ModifyStopLoss(double ldStopLoss) {
  bool fm;

  fm=OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,Yellow);
  if (fm && UseSound) PlaySound(NameFileSound);
}
//--------------------------------------------------------------------------------------// 

